config/routes.rb
Rails.application.routes.draw do
  ActiveAdmin.routes(self)
  devise_for :users
  root 'places#index'
  resources :places, only: [:index, :show]
  resources :dishes, only: [] do
    member do
      post :make_order
      put :plus_qty_to_product
      put :minus_qty_to_product
    end
  end
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/ability.rb
# frozen_string_literal: true

class Ability
  include CanCan::Ability

  def initialize(user)
    can :read, Dish
    can :read, Place
    if user.present?
      can :make_order, Dish
        if user.admin?
            can :manage, :all
        end
    end
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/dish.rb
class Dish < ApplicationRecord
  belongs_to :place

  has_one_attached :picture

  validates :name, presence: true, length: { in: 2..50 }
  validates :desc, presence: true, length: { in: 2..250 }
  validates :price, presence: true, numericality: { only_float: true, greater_than: 1 }
  end

app/models/place.rb
class Place < ApplicationRecord
  has_many :dishes, dependent: :destroy
  has_one_attached :avatar

  validates :name, presence: true, length: { in: 2..50 }
  validates :desc, presence: true, length: { in: 2..500 }
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
  :recoverable, :rememberable, :validatable

  validates :name, presence: true, length: { in: 2..20 }
  validates :phone, presence: true, length: { in: 5..20 }
  validates :adress, presence: true, length: { in: 5..100 }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :configure_permitted_parameters, if: :devise_controller?

  rescue_from CanCan::AccessDenied do |exception|
    flash[:danger] = exception.message
    redirect_back(fallback_location: root_path )
  end

  def access_denied(exception)
    flash[:danger] = exception.message
    redirect_back(fallback_location: root_path )
  end

  protected

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:name, :phone, :adress, :email, :password])
    devise_parameter_sanitizer.permit(:account_update, keys: [:name, :phone, :adress, :email, :password])
  end

end

app/controllers/dishes_controller.rb
class DishesController < ApplicationController
  before_action :authenticate_user!, only: [:make_order]
  before_action :set_dish, only: [:show, :make_order, :plus_qty_to_product, :minus_qty_to_product]

  def index
    @dishes = Dish.all
  end

  def show
  end

  def make_order
    session[:order_cart] ||= {}
    session[:order_cart]["#{@dish.place.id}"] ||= {}
    session[:order_cart]["#{@dish.place.id}"]["orders"] ||= []
    already =  session[:order_cart]["#{@dish.place.id}"]["orders"].find{ |order| order["dish_id"] == @dish.id }

    if already
      add_qty_product
    else
      session[:order_cart]["#{@dish.place.id}"]["orders"].push({"dish_id" => @dish.id, "price" => @dish.price, "qty" => 1})
    end

    redirect_back(fallback_location:root_path)
  end

  def plus_qty_to_product
    session[:order_cart]["#{@dish.place.id}"]["orders"].each do |order|
      if order["dish_id"] == @dish.id
        order["qty"] += 1
      end
    end
    redirect_back(fallback_location:root_path)
  end

  def minus_qty_to_product
    session[:order_cart]["#{@dish.place.id}"]["orders"].each do |order|
      if order["dish_id"] == @dish.id
        order["qty"] -= 1 if order["qty"] > 1
      end
    end
    redirect_back(fallback_location:root_path)
  end

  private
  def add_qty_product
    session[:order_cart]["#{@dish.place.id}"]["orders"].each do |order|
      if order["dish_id"] == @dish.id
        order["qty"] += 1
      end
    end
  end

  def set_dish
    @dish = Dish.find(params[:id])
  end
end

app/controllers/places_controller.rb
class PlacesController < ApplicationController
  before_action :set_place, only: [:show]

  def index
    @places = Place.all
  end

  def show
    @dishes = @place.dishes

    if session[:order_cart] && session[:order_cart]["#{@place.id}"]
      @shop_cart = []
      dish = nil
      @total_price = 0
      session[:order_cart]["#{@place.id}"]["orders"].each do |order|
        dish = Dish.find(order["dish_id"])
        price = order["price"]
        qty = order["qty"]
        item = { dish: dish, price: price, qty: qty, sum: qty.to_i * price.to_f }
        @shop_cart.push(item)
        @total_price += item[:sum]
      end
    end

  end

  private
  def set_place
    @place = Place.find(params[:id])
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/dishes_helper.rb
module DishesHelper
end

app/helpers/places_helper.rb
module PlacesHelper
end

app/views/dishes/_dish.html.erb
<div class="col-12 col-sm-6 col-lg-4 mb-3">
  <div class="card h-100 dishCard">
    <% if dish.picture.attached? %>
    <%= image_tag dish.picture, :class => 'card-img-top' %>
    <% end %>
    <div class="card-body d-flex align-items-center flex-column  text-center">
      <h5 class="card-title"><%= dish.name %></h5>
      <p class="card-text"><%= dish.desc %></p>
      <div class="buttonsGroup mt-auto">
        <%= dish.price %>
        <%= link_to 'Make order', make_order_dish_path(dish), :class => 'btn btn-primary', method: :post %>
      </div>
    </div>
  </div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>FoodGood</title>
  <%= csrf_meta_tags %>
  <%= csp_meta_tag %>

  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
</head>

<body>
<header class="bg-dark">
    <div class="container">
      <nav class="navbar navbar-expand-md navbar-dark bg-dark">
        <%= link_to 'Home', root_path, :class => 'navbar-brand' %>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
          <ul class="navbar-nav ml-auto">
            <% if user_signed_in? %>
            <li class="nav-item">
              <p class="nav-link text-white m-0">Hello,</p>
            </li>
            <li class="nav-item dropdown text-black">
              <%= link_to current_user.email, '#', id: 'navbarDropdown', role: 'button', data: { toggle: 'dropdown' }, :class => ' btn btn-light' %>
            </a>
            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
              <%= link_to 'Admin Panel' , admin_root_path, :class => 'dropdown-item' if can? :read, ActiveAdmin::Page %>
              <%= link_to 'Edit profile', edit_user_registration_path, :class => 'dropdown-item' %>
              <%= link_to 'Log Out', destroy_user_session_path, :class => 'dropdown-item', method: :delete %>
            </div>
          </li>
          <% else %>
          <li class="nav-item <%= 'active' if current_page?(new_user_session_path) %>">
            <%= link_to "Log in", new_user_session_path, :class => 'nav-link' %>
          </li>
          <li class="nav-item <%= 'active' if current_page?(new_user_registration_path) %>">
            <%= link_to "Sign in", new_user_registration_path, :class => 'nav-link' %>
          </li>
          <% end %>
        </ul>
      </div>
    </nav>
  </div>
</header>


  <div class="container my-2">
    <% flash.each do |alert, message| %>
    <%= content_tag 'div', message, :class => "alert alert-#{alert}" %>
    <% end %>
    <%= yield %>
  </div>
</body>
</html>

app/views/places/index.html.erb
<h1>Places</h1>
<div class="row">
  <% @places.each do |place| %>
  <div class="col-6 col-md-4 mb-3">
    <div class="card h-100 placeCard">
      <% if place.avatar.attached?%>
      <%= image_tag place.avatar, :class => 'card-img-top' %>
      <% end %>
      <div class="card-body d-flex align-items-center flex-column  text-center">
        <h5 class="card-title"><%= place.name %></h5>
        <p class="card-text"><%= place.desc[0..120] %>...</p>
        <%= link_to 'Show', place, :class => 'btn btn-primary mt-auto' %>
      </div>
    </div>
  </div>
  <% end %>
</div>

app/views/places/show.html.erb
<div class="placeShowDesc">
  <h2><%= @place.name %></h2>
  <% if @place.avatar.attached? %>
  <%= image_tag @place.avatar%>
  <% end %>
  <p>
    <%= @place.desc %>
  </p>
</div>
<%= link_to 'Back', places_path %>
<hr>

<h4>Dishes</h4>
<% if @shop_cart && !@shop_cart.empty? %>
<div class="row">
  <div class="col-3">
    <div class="card">
      <ul class="list-group list-group-flush">
        <% @shop_cart.each do |item| %>
        <li class="list-group-item">
          <div class="dishCardItem">
            <p>
              <%= item[:dish].name %> x
              <%= link_to '-', minus_qty_to_product_dish_path(item[:dish]), :class => 'minusItem', method: :put if item[:qty] > 1 %>
              <%= item[:qty] %>
              <%= link_to '+', plus_qty_to_product_dish_path(item[:dish]), :class => 'plusItem', method: :put %>
            </p>
            <%= item[:price] %> x <%= item[:qty] %> = <%= item[:sum] %>

          </div>
        </li>
        <% end %>
        <li class="list-group-item bg-success">
          <p class="p-0 m-0"><b>Total price:</b> <%= @total_price %> </p>
        </li>
      </ul>
    </div>
  </div>
  <div class="col-9">
    <div class="row">
      <%= render @dishes %>
    </div>
  </div>
</div>
<% else %>
<div class="row">
  <%= render @dishes %>
</div>
<% end %>
<br>